#ifndef GETS_C
#define GETS_C

/* Small c library, by Jeremy Dewey (jxd45@po.cwru.edu)
   http://www.seashellinc.com/jdewey

   Synopsis:
      gets(char* str, int max)

   Description:
      gets() reads a line from the keyboard, most useful with GETC_CMP defined.

   Example: 
     char name[20]; 
     gets(name, 20);

   Notes:
      This function looks really ugly if the input line wraps at the bottom of
      the screen, due to the handling of the backspace.

*/

#include "lib\getc.c"

gets(str, max) char* str; int max; {
   char c,ptr,startx,starty;

   startx = _text_x;
   starty = _text_y;
   ptr = 0;
   c = 0;

   while (1) {
      c = getc();
      if (c == K_ENTER || ptr == max-1) return ptr;
      if (c == K_LEFT) {
         str[--ptr] = 0;
         setxy(startx, starty);
         puts(str); putc(' ');
         setxy(startx, starty);
         puts(str);
      }
      else {
         str[ptr++] = c;
         str[ptr] = 0;
         putc(c);
      }
   }
}
#endif
