#ifndef HVLINE_C
#define HVLINE_C

/* Small c library, by Jeremy Dewey (jxd45@po.cwru.edu)
   http://www.seashellinc.com/jdewey

   Synopsis:
      hline(char x1, char x2, char y)
      vline(char y1, char y2, char x)

   Description:
      Draws a horizontal or vertical line

   Example:
      hline(0, 10, 5)
      vline(0, 10, 5)

   Notes:
      o The first parameter must be smaller than the second

*/

hline(x1, x2, y) char x1, x2, y; {
#asm
   ld  hl,2
   add hl,sp
   ld  c,(hl)
   inc hl
   inc hl
   ld  e,(hl)
   inc hl
   inc hl
   ld  b,(hl)
   dec b
_hlloop:
   push de
   inc b
   CALL_(_chgpix)
   pop de
   ld  a,e
   cp  b
   jr  nz,_hlloop
#endasm
}

vline(y1, y2, x) char y1, y2, x; {
#asm
   ld  hl,2
   add hl,sp
   ld  b,(hl)
   inc hl
   inc hl
   ld  e,(hl)
   inc hl
   inc hl
   ld  c,(hl)
   dec c
_vlloop:
   inc c
   push de
   CALL_(_chgpix)
   pop de
   ld  a,e
   cp  c
   jr  nz,_vlloop
#endasm
}

#endif
