/* Point.c - draws a neat little n-gon

   This is a sample program to demonstrate many of the features and
   constructs of small c. As such, it is not optimized in any way.
*/


#include "zslib.h"
#include "lib\line.c"

#define SIZE_X 35
#define SIZE_Y 27
#define BALL_X 63
#define BALL_Y 35

extern char arrows[];
extern char sin_data[57];  /* sin table at bottom of file */
extern int last_num;       /* used to save the number of edges */
int nEdges;                /* Temporary copy of last_num since
                              static/extern access is expensive */
char px[19],py[19];
char key;

main() {
   nEdges = last_num;
   clrscr;
   graphpage();
   instr();
   initball();
   redraw();
   while ((key=getkey()) != K_EXIT) {
      if (key==K_UP) {
         nEdges++;
         if (nEdges > 19) nEdges = 3;
      }
      if (key==K_DOWN) {
         nEdges--;
         if (nEdges < 3) nEdges = 19;
      }
      initball();
      redraw();
   }
   last_num = nEdges;
}

redraw() {
   clrscr;
   line(0,8,127,8);
   setxy_m(0,56);
   puts_m("Num Points:  ");
   if (nEdges > 9) putc_m('1');
   putc_m(nEdges % 10 + '0');
   setxy_m(112,56);
   puts_m(arrows);
   drawball();

}

drawball() {
   int i,j;
   for(i=0;i<nEdges-1;i++)
      for(j=i+1;j<nEdges;j++)
         line(px[i],py[i],px[j],py[j]);
}

initball() {
   int i;
   for(i=0;i<nEdges;i++) {
      /* I believe the order of operations is important to maintain
         accuracy here */
      px[i] = BALL_X + sin_data[36*i/nEdges + 9] * SIZE_X / 128;
      py[i] = BALL_Y + sin_data[36*i/nEdges]     * SIZE_Y / 128;
   }
}

instr() {
   setxy(0,0);
   invtext;
   puts("                     ");
   setxy_m(11,1);
   puts_m("Points - a small c Graphics Demo");
   normtext;
   setxy_m(9,8);
   puts_m("www.SEAshellInc.com/jdewey");
   setxy_m(0,47);
   puts_m("Use ");
   puts_m(arrows);
   puts_m(" to change the number of points");
   setxy_m(14,55);
   puts_m("Press [ENTER] to run the demo");
   if (getkey()== K_EXIT) exit();
   clrscr;
}



#asm
; sin table from 0 to 450 degrees (sin * 128)
; this table is smaller than the code needed to
; use a 90 degree table

sin_data:
.db 0,22,44,64,82,98,111,120,126,127
.db 126,120,111,98,82,64,44,22,0
.db -22,-44,-64,-82,-98,-111,-120,-126,-127
.db -126,-120,-111,-98,-82,-64,-44,-22
.db 0,22,44,64,82,98,111,120,126,127

last_num:
.dw 10  ; Initial number of edges

arrows:
.db 6,'/',7,0
#endasm
