/*	File code8080.c: 2.2 (84/08/31,10:05:09) */
/*% cc -O -c %
 *
 */

#include <stdio.h>
#include "defs.h"
#include "data.h"

/*	Define ASNM and LDNM to the names of the assembler and linker
	respectively */

/*
 *	Some predefinitions:
 *
 *	INTSIZE is the size of an integer in the target machine
 *	BYTEOFF is the offset of an byte within an integer on the
 *		target machine. (ie: 8080,pdp11 = 0, 6809 = 1,
 *		360 = 3)
 *	This compiler assumes that an integer is the SAME length as
 *	a pointer - in fact, the compiler uses INTSIZE for both.
 */
#define	INTSIZE	2
#define	BYTEOFF	0

int	savestkp;

/*
 *	print all assembler info before any code is generated
 *
 */
header (n)
char	*n;
{
	outstr (";\tSmall C z80 (ZShell edition);\n;\tCoder (3.3,97/3/23)\n;");
	FEvers();
	nl ();
	outstr ("#include \"ti-85.h\"\n");
   outstr (".org 0\n");
   outstr (".db\t\"");
   outstr (n);
   outstr ("\",0\n");
   outstr ("#include \"zs_crt0.asm\"\n");
}

nl ()
{
	outbyte (EOL);
}

inclib()
{
   char* inc;
   inc = findmac("INCLUDE");
   if (inc) return inc;
	return("");
}

initmac()
{
	defmac("Z80\t1");
   defmac("ZSHELL\t1");
	defmac("SMALLC\t1");
}

galign(t)
int	t;
{
	return(t);
}

/*
 *	return size of an integer
 */
intsize() {
	return(INTSIZE);
}

/*
 *	return offset of ls byte within word
 *	(ie: 8080 & pdp11 is 0, 6809 is 1, 360 is 3)
 */
byteoff() {
	return(BYTEOFF);
}

/*
 *	Output internal generated label prefix
 */
olprfix() {
	outbyte('_');
}

/*
 *	Output a label definition terminator
 */
col ()
{
	outbyte (58);
}

/*
 *	begin a comment line for the assembler
 *
 */
comment ()
{
	outbyte (';');
}

/*
 *	Emit user label prefix
 */
prefix ()
{
}


/*
 *	print any assembler stuff needed after all code
 *
 */
trailer ()
{
	outstr (".end\n");
}

/*
 *	function prologue
 */
prologue ()
{
}

#ifdef	FRAME_IX
/*
 *	set up frame pointer
 */
frame ()
{
	ol ("push\tix");
	/* make ix point to where sp was before push */
	ol ("ld\tix,0");
	ol ("add\tix,sp");
	stkp = stkp - INTSIZE;
	savestkp = stkp;
	return (INTSIZE);
}
#endif

/*
 *	text (code) segment
 */
gtext ()
{
   outstr ("; text segment\n");
}

/*
 *	data segment
 */
gdata ()
{
   outstr ("; data segment\n");
}

/*
 *	bss segment
 */
gbss ()
{
   outstr ("; Temporary data stored in Text Memory\n");
}

/*
 *  Output the variable symbol at scptr as an extrn or a public
 */
ppubext(scptr) char *scptr; {
   return; /* There is no need for externs */
	/*
   if (cptr[STORAGE] == STATIC) {
      outstr (";.static\t");
      prefix ();
      outstr (scptr);
      nl ();
   	return;
   }
	outstr (scptr[STORAGE] == EXTERN ? ";.extern\t" : ";.auto\t");
	prefix ();
	outstr (scptr);
	nl();
   */
}

/*
 * Output the function symbol at scptr as an extrn or a public
 */
fpubext(scptr) char *scptr; {
	if (scptr[STORAGE] == STATIC) return;
	/*
   ot (scptr[OFFSET] == FUNCTION ? ".globl\t" : ".globl\t");
	prefix ();
	outstr (scptr);
	nl ();
   */
}

/*
 *  Output a decimal number to the assembler file
 */
onum(num) int num; {
	outdec(num);	/* pdp11 needs a "." here */
}


/*
 *	fetch a static memory cell into the primary register
 */
getmem (sym)
char	*sym;
{
	if (sym[STORAGE]==STATIC || sym[STORAGE] == EXTERN) {
		if ((sym[IDENT] != POINTER) & (sym[TYPE] == CCHAR)) {
         ol ("ld\thl,(PROGRAM_ADDR)");
         ot ("ld\tbc,");
  			outstr (sym + NAME);
         nl ();
         ol ("add\thl,bc");
			ot ("ld\ta,(hl)");
#ifdef	FRAME_IX
			ot (";static");
#endif
		 	nl ();
			gcall ("_sxt");
		} else {
         ol ("ld\thl,(PROGRAM_ADDR)");
         ot ("ld\tbc,");
			outstr (sym + NAME);
			nl ();
         ol ("add\thl,bc");
         ol ("ld\tc,(hl)"); /* Is this the right order? */
         ol ("inc\thl");
         ol ("ld\th,(hl)");
         ot ("ld\tl,c");
#ifdef	FRAME_IX
			ot (";static");
#endif
			nl ();
		}
	} else { /* Not STATIC */
		if ((sym[IDENT] != POINTER) & (sym[TYPE] == CCHAR)) {
			ot ("ld\ta,(");
			outstr (sym + NAME);
			outbyte(')');
#ifdef	FRAME_IX
			ot (";static");
#endif
		 	nl ();
			gcall ("_sxt");
		} else {
			ot ("ld\thl,(");
			outstr (sym + NAME);
			outbyte(')');
#ifdef	FRAME_IX
			ot (";static");
#endif
			nl ();
		}
   }
}

/*
 *	fetch the address of the specified symbol into the primary register
 *
 */
getloc (sym)
char	*sym;
{
	int	i;

	immed ();
	if (sym[STORAGE] == LSTATIC) {
		printlabel(glint(sym));
#ifdef	FRAME_IX
		ot (";static");
#endif
		nl();
      ol ("ld\tbc,(PROGRAM_ADDR)");
      ol ("add\thl,bc");
	} else {
		outdec (glint(sym) - stkp);
#ifdef	FRAME_IX
		/* generate the annotation only if in range of (ix) addressing */
		if ((i = glint(sym) - savestkp) >= -128 && i <= 127)
		{
			ot (";");
			outdec (i);
			outstr ("(ix)");
		}
#endif
		nl ();
		ol ("add\thl,sp");
	}
}

/*
 *	store the primary register into the specified static memory cell
 *
 */
putmem (sym)
char	*sym;
{
	if (sym[STORAGE]==STATIC || sym[STORAGE]==LSTATIC || sym[STORAGE]==EXTERN) {
		if ((sym[IDENT] != POINTER) & (sym[TYPE] == CCHAR)) {
			ol ("ld\ta,l");
         ol ("ld\thl,(PROGRAM_ADDR)");
         ot ("ld\tbc,");
			outstr (sym + NAME);
			nl ();
         ol ("add\thl,bc");
         ol ("ld\t(hl),a");
		} else {
			ol ("push\thl");
         ol ("ld\thl,(PROGRAM_ADDR)");
         ot ("ld\tbc,");
			outstr (sym + NAME);
         nl ();
         ol ("add\thl,bc");
         ol ("pop\tbc");
#ifdef	FRAME_IX
			ol ("ld\t(hl),c\t;static"); /* Is this the right order? */
#else
			ol ("ld\t(hl),c");
#endif
			ol ("inc\thl");
         ol ("ld\t(hl),b");
		}
	} else { /* Not (L)STATIC */
		if ((sym[IDENT] != POINTER) & (sym[TYPE] == CCHAR)) {
			ol ("ld\ta,l");
			ot ("ld\t(");
			outstr (sym + NAME);
			outstr ("),a");
			nl ();
		} else {
			ot ("ld\t(");
			outstr (sym + NAME);
#ifdef	FRAME_IX
			outstr ("),hl\t;static");
#else
			outstr ("),hl");
#endif
			nl ();
		}
   }
}

/*
 *	store the specified object type in the primary register
 *	at the address on the top of the stack
 *
 */
putstk (typeobj)
char	typeobj;
{
	gpop ();
	if (typeobj == CCHAR)
		gcall ("_pchar");
	else
		gcall ("_pint");
}

/*
 *	fetch the specified object type indirect through the primary
 *	register into the primary register
 *
 */
indirect (typeobj)
char	typeobj;
{
	if (typeobj == CCHAR)
		gcall ("_gchar");
	else
		/* gcall ("_gint");*/
      ol ("call\tLD_HL_MHL");
}

/*
 *	swap the primary and secondary registers
 *
 */
swap ()
{
	ol ("ex\tde,hl");
}

/*
 *	print partial instruction to get an immediate value into
 *	the primary register
 *
 */
immed ()
{
	ot ("ld\thl,");
}

/*
 *	push the primary register onto the stack
 *
 */
gpush ()
{
	ol ("push\thl");
	stkp = stkp - INTSIZE;
}

/*
 *	pop the top of the stack into the secondary register
 *
 */
gpop ()
{
	ol ("pop\tde");
	stkp = stkp + INTSIZE;
}

/*
 *	swap the primary register and the top of the stack
 *
 */
swapstk ()
{
	ol ("ex\t(sp),hl");
}

/*
 *	call the specified subroutine name
 *
 */
gcall (sname)
char	*sname;
{
	ot ("CALL_(");
	outstr (sname);
	outbyte (')');
   nl ();
}

/*
 *	return from subroutine
 *
 */
gret ()
{
	if (frameix)
		ol ("pop\tix");
	ol ("ret");
}

/*
 *	perform subroutine call to value on top of stack
 *
 */
callstk ()
{
	immed ();
	outstr ("$+5");
	nl ();
	swapstk ();
	ol ("jp\t(hl)");
	stkp = stkp + INTSIZE;
}

/*
 *	jump to specified internal label number
 *
 */
jump (label)
int	label;
{
	ot ("JUMP_(");
	printlabel (label);
	outbyte (')');
   nl ();
}

/*
 *	test the primary register and jump if false to label
 *
 */
testjump (label, ft)
int	label,
	ft;
{
	ol ("ld\ta,h");
	ol ("or\tl");
	if (ft)
		ot ("JUMP_NZ(");
	else
		ot ("JUMP_Z(");
	printlabel (label);
   outbyte (')');
	nl ();
}

/*
 *	print pseudo-op  to define a byte
 *
 */
defbyte ()
{
	outstr (".db\t");
}

/*
 *	print pseudo-op to define storage
 *
 */
defstorage ()
{
	outstr (".ds\t");
}

/*
 *	print pseudo-op to define a word
 *
 */
defword ()
{
	outstr (".dw\t");
}

/*
 *	modify the stack pointer to the new value indicated
 *
 */
modstk (newstkp)
int	newstkp;
{
	int	k;

	k = galign(newstkp - stkp);
	if (k == 0)
		return (newstkp);
	if (k > 0) {
		if (k < 7) {
			if (k & 1) {
				ol ("inc\tsp");
				k--;
			}
			while (k) {
				ol ("pop\tbc");
				k = k - INTSIZE;
			}
			return (newstkp);
		}
	} else {
		if (k > -7) {
			if (k & 1) {
				ol ("dec\tsp");
				k++;
			}
			while (k) {
				ol ("push\tbc");
				k = k + INTSIZE;
			}
			return (newstkp);
		}
	}
	swap ();
	immed ();
	outdec (k);
	nl ();
	ol ("add\thl,sp");
	ol ("ld\tsp,hl");
	swap ();
	return (newstkp);
}

/*
 *	multiply the primary register by INTSIZE
 */
gaslint ()
{
	ol ("add\thl,hl");
}

/*
 *	divide the primary register by INTSIZE
 */
gasrint()
{
	gpush();	/* push primary in prep for gasr */
	immed ();
	onum (1);
	nl ();
	gasr ();  /* divide by two */
}

/*
 *	Case jump instruction
 */
gjcase() {
   inccase = 1;
	ot ("JUMP_(_case)");
	nl ();
}

/*
 *	add the primary and secondary registers
 *	if lval2 is int pointer and lval is not, scale lval
 */
gadd (lval,lval2) int *lval,*lval2;
{
	gpop ();
	if (dbltest (lval2, lval)) {
		swap ();
		gaslint ();
		swap ();
	}
	ol ("add\thl,de");
}

/*
 *	subtract the primary register from the secondary
 *
 */
gsub ()
{
	gpop ();
	gcall ("_sub");
}

/*
 *	multiply the primary and secondary registers
 *	(result in primary)
 *
 */
gmult ()
{
   incmult = 1;
   gpop();
	gcall ("_mul");
}

/*
 *	divide the secondary register by the primary
 *	(quotient in primary, remainder in secondary)
 *
 */
gdiv ()
{
   incdiv = 1;
	gpop();
	gcall ("_div");
}

/*
 *	compute the remainder (mod) of the secondary register
 *	divided by the primary register
 *	(remainder in primary, quotient in secondary)
 *
 */
gmod ()
{
   incdiv = 1;
	gdiv ();
	swap ();
}

/*
 *	inclusive 'or' the primary and secondary registers
 *
 */
gor ()
{
	gpop();
	gcall ("_or");
}

/*
 *	exclusive 'or' the primary and secondary registers
 *
 */
gxor ()
{
	gpop();
	gcall ("_xor");
}

/*
 *	'and' the primary and secondary registers
 *
 */
gand ()
{
	gpop();
	gcall ("_and");
}

/*
 *	arithmetic shift right the secondary register the number of
 *	times in the primary register
 *	(results in primary register)
 *
 */
gasr ()
{
	gpop();
	gcall ("_asr");
}

/*
 *	arithmetic shift left the secondary register the number of
 *	times in the primary register
 *	(results in primary register)
 *
 */
gasl ()
{
	gpop ();
	gcall ("_asl");
}

/*
 *	two's complement of primary register
 *
 */
gneg ()
{
	gcall ("_neg");
}

/*
 *	logical complement of primary register
 *
 */
glneg ()
{
	gcall ("_lneg");
}

/*
 *	one's complement of primary register
 *
 */
gcom ()
{
	gcall ("_com");
}

/*
 *	Convert primary value into logical value (0 if 0, 1 otherwise)
 *
 */
gbool ()
{
	gcall ("_bool");
}

/*
 *	increment the primary register by 1 if char, INTSIZE if
 *      int
 */
ginc (lval) int lval[];
{
	ol ("inc\thl");
	if (lval[2] == CINT)
		ol ("inc\thl");
}

/*
 *	decrement the primary register by one if char, INTSIZE if
 *	int
 */
gdec (lval) int lval[];
{
	ol ("dec\thl");
	if (lval[2] == CINT)
		ol("dec\thl");
}

/*
 *	following are the conditional operators.
 *	they compare the secondary register against the primary register
 *	and put a literl 1 in the primary if the condition is true,
 *	otherwise they clear the primary register
 *
 */

/*
 *	equal
 *
 */
geq ()
{
	gpop();
	gcall ("_eq");
}

/*
 *	not equal
 *
 */
gne ()
{
	gpop();
	gcall ("_ne");
}

/*
 *	less than (signed)
 *
 */
glt ()
{
	gpop();
	gcall ("_lt");
}

/*
 *	less than or equal (signed)
 *
 */
gle ()
{
	gpop();
	gcall ("_le");
}

/*
 *	greater than (signed)
 *
 */
ggt ()
{
	gpop();
	gcall ("_gt");
}

/*
 *	greater than or equal (signed)
 *
 */
gge ()
{
	gpop();
	gcall ("_ge");
}

/*
 *	less than (unsigned)
 *
 */
gult ()
{
	gpop();
	gcall ("_ult");
}

/*
 *	less than or equal (unsigned)
 *
 */
gule ()
{
	gpop();
	gcall ("_ule");
}

/*
 *	greater than (unsigned)
 *
 */
gugt ()
{
	gpop();
	gcall ("_ugt");
}

/*
 *	greater than or equal (unsigned)
 *
 */
guge ()
{
	gpop();
	gcall ("_uge");
}

/*	Squirrel away argument count in a register that modstk
	doesn't touch.
*/

gnargs(d)
int	d; {
	ot ("ld\ta,");
	onum(d);
	nl ();
}
